<?php
/**
* @version		$Id: plg_openmenu.php 14401 2012-01-10 14:10:00Z chris $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2014 OpenMenu. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// FORMAT: {menu url,menu filter,groupfilter}

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');
jimport( 'joomla.html.parameter' );
require_once( dirname(__FILE__).'/plg_helper.php' );
$document=JFactory::getDocument();
$document->addStyleSheet(JURI::base().'plugins/content/plg_openmenu/styles/style.css');
//$document->addScript('https://ajax.googleapis.com/ajax/libs/jquery/1.6.2/jquery.min.js');
$document->addScript('http://maps.google.com/maps/api/js?sensor=true');

class plgContentplg_openmenu extends JPlugin {

	protected $icon_path = null;

	/**
	 * Plugin for backward compatibility to 1.5
	 * @param	mixed	An object with a "text" property or the string to be cloaked.
	 * @param	array	Additional parameters.
	 * @param	int		Optional page number. Unused. Defaults to zero.
	 * @return	boolean	True on success.
	 */
	public function onPrepareContent( &$row, &$params, $limitstart=0 ) {
		$this->_getMenu($row, $params);
		return true;
	}

	/**
	 * Plugin that replaces {openmenu omf=""} with an OpenMenu info box Joomla1.6
	 *
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	mixed	An object with a "text" property or the string to be cloaked.
	 * @param	array	Additional parameters.
	 * @param	int		Optional page number. Unused. Defaults to zero.
	 * @return	boolean	True on success.
	 */
	public function onContentPrepare($context, &$row, &$params, $limitstart=0 ) {
		$this->_getMenu($row, $params);
		return true;
	}
	
	private function parse_atts($atts) {
		$atts = html_entity_decode($atts);
		$pattern = '/(\\w+)\s*=\\s*("[^"]*"|\'[^\']*\'|[^"\'\\s>]*)/';
		preg_match_all($pattern, $atts, $matches, PREG_SET_ORDER);
		$attrs = array();
		foreach ($matches as $match) {
		    $name = strtolower($match[1]);
		    $attrs[$name] = trim($match[2], '"');
		}
		return $attrs;
	}

	protected function _getMenu(&$row, &$params ) {
		// find tags in content-text
		preg_match_all('/\[openmenu (.*?)\]/',$row->text, $matches);
		
		// Grab the default settings
		$default_display_columns = $this->params->get('display_columns');
		$default_display_type = $this->params->get('display_type');
		$default_split_on = $this->params->get('split_on');		
		$default_background_color = $this->params->get('background_color');
		$show_allergy = $this->params->get('show_allergy');
		$show_calories = $this->params->get('show_calories');
		$hide_prices = $this->params->get('hide_prices');
		$default_use_short_tag =  $this->params->get('use_short_tag');
		$default_group_break =  $this->params->get('group_break');
		
		foreach($matches[1] as $wparam ) {
			$atts = $this->parse_atts($wparam);
			
			$omf_url =  ( isset($atts['omf_url']) ) ? $atts['omf_url'] : '' ;
			$menu_filter =  ( isset($atts['menu_filter']) ) ? $atts['menu_filter'] : '' ;
			$group_filter =  ( isset($atts['group_filter']) ) ? $atts['group_filter'] : '' ;
			$display_columns =  ( isset($atts['display_columns']) ) ? $atts['display_columns'] : $default_display_columns ;
			$display_type =  ( isset($atts['display_type']) ) ? $atts['display_type'] : $default_display_type ;
			$split_on =  ( isset($atts['split_on']) ) ? $atts['split_on'] : $default_split_on ;
			$background_color =  ( isset($atts['background_color']) ) ? $atts['background_color'] : $default_background_color ;
			$use_short_tag =  ( isset($atts['use_short_tag']) ) ? $atts['use_short_tag'] : $default_use_short_tag ;
			$group_break =  ( isset($atts['group_break']) ) ? $atts['group_break'] : $default_group_break ;
			
			$display='';
			if ( !empty( $omf_url ) ) {
				// Get the menu
				$omf_details = _get_menu_details( $omf_url );
	            ob_start();

?>

      <div id="openmenu">

<?php 
	// Display the restaurant information
	if ( strcasecmp($display_type, 'restaurant information / menu') == 0 || 
	  strcasecmp($display_type, 'restaurant information') == 0 ) {
?>

	<script type="text/javascript">
		var $j = jQuery.noConflict();
		var geocoder;
		var map;
	    var image = '<?php echo JURI::base().'modules/mod_openmenu' ; ?>/images/ico-32-restaurant.png';

		$j(document).ready(function() {
			// Initialize the mapping stuff
			initialize();

<?php

	// If we have the cords then no need to geo-code
	if (!empty($omf_details['restaurant_info']['latitude']) && !empty($omf_details['restaurant_info']['longitude'])) {
		echo 'map_cords("'.$omf_details['restaurant_info']['latitude'].'", "'.$omf_details['restaurant_info']['longitude'].'");';
	} else {
		echo 'map_address("'.$omf_details['formatted_address'].'");';
	}
	
?>
		});

	  function initialize() {
	    geocoder = new google.maps.Geocoder();
	    var myOptions = {
	      zoom: 14,
	      mapTypeId: google.maps.MapTypeId.ROADMAP
	    }
	    map = new google.maps.Map(document.getElementById("locationmap"), myOptions);
	  }

	  function map_cords(lat, lng) {
		var myLatLng = new google.maps.LatLng(lat, lng);
		var marker = new google.maps.Marker({
		    position: myLatLng,
		    map: map,
		    icon: image
		});
		map.setCenter(new google.maps.LatLng(lat, lng));
	  }

	  function map_address(address) {
	    if (geocoder) {
	      geocoder.geocode( { 'address': address}, function(results, status) {
	        if (status == google.maps.GeocoderStatus.OK) {
	          map.setCenter(results[0].geometry.location);
	          var marker = new google.maps.Marker({
	              map: map, 
	              icon: image, 
	              position: results[0].geometry.location,
	              title: '<?php echo addslashes($omf_details['restaurant_info']['restaurant_name']); ?>'
	          });
	        } else {
	          // alert("Geocode could not process the requested address\n" + status);
	        }
	      });
	    }
	  }
	</script>

			<div id="om_restaurant">

				<div id="location-map"> 
					<div id="locationmap"></div>
				</div>
				
				<!--
				<div id="rest_name"><?php echo $omf_details['restaurant_info']['restaurant_name']; ?></div>
				-->

				<div id="details">
		            <p><?php echo $omf_details['restaurant_info']['brief_description']; ?></p>
		            <p>
		            	<strong><?php echo 'Address'; ?>:</strong><br />
		            	<?php echo $omf_details['restaurant_info']['address_1']; ?><br />
		            	<?php echo $omf_details['restaurant_info']['city_town']; ?>, <?php echo $omf_details['restaurant_info']['state_province']; ?> <?php echo $omf_details['restaurant_info']['postal_code']; ?> <?php echo $omf_details['restaurant_info']['country']; ?>
		            </p>
		            <p>
			            <strong><?php echo 'Phone'; ?>: </strong> <?php echo $omf_details['restaurant_info']['phone']; ?><br />
			            <strong><?php echo 'Website'; ?>: </strong> <a href="<?php echo $omf_details['restaurant_info']['website_url']; ?>"><?php echo $omf_details['restaurant_info']['website_url']; ?></a>
		            </p>
		            
		            <p>
		            	<strong><?php echo 'Hours'; ?>:</strong><br />
<?php 
	foreach ($omf_details['operating_days']['printable'] AS $daytime) {
		echo $daytime.'<br />';
	}
?>
			        </p>
			        
			        <div><strong><?php echo 'Type'; ?>:</strong> <?php echo $omf_details['environment_info']['cuisine_type_primary']; ?></div>
				</div>

			<div class="clear"></div>
		</div>
		
		
<?php 
	} // end restaurant info
   
            
            $display = ob_get_contents();

            ob_end_clean();
            
                       		
			
			if ( strcasecmp($display_type, 'restaurant information / menu') == 0 || 
	 strcasecmp($display_type, 'menu') == 0 ) {
	 	
				$display .= build_menu_from_details($omf_details, $display_columns, $menu_filter, $group_filter, $background_color, $split_on, $show_allergy, $show_calories, $use_short_tag, $hide_prices, $group_break);
			}			
		} else {
			$display = 'OpenMenu must be provided';
		}
	
			// replace tag with code
			$row->text = str_replace("[openmenu $wparam]", $display, $row->text);
		}
		return true;
	}

	// a bit complicate but if the simpleXML replacement is not 100% compatible
	protected function getData( $node ) {
		if ($node) {
			$data = $node->attributes();
			return $data['data'];
		}
	}

}